SystemOrganization addCategory: #'Magma-Squeak-Client-Application'!
SystemOrganization addCategory: #'Magma-Squeak-Client'!

TheWorldMainDockingBar subclass: #MagmaWorldMainDockingBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Squeak-Client'!

!MagmaWorldMainDockingBar methodsFor: 'overridden' stamp: 'cmm 9/11/2011 21:56'!
applicationMenusOn: aDockingBarMenuMorph
	"Subclasses add their custom menus to aDockingBarMenuMorph."! !

!MagmaWorldMainDockingBar methodsFor: 'accessing' stamp: 'cmm 9/11/2011 20:57'!
applicationName
	self subclassResponsibility! !

!MagmaWorldMainDockingBar methodsFor: 'app menu' stamp: 'cmm 9/11/2011 22:40'!
exitWorldMenuItemOn: aDockingBarMenuMorph 
	aDockingBarMenuMorph
		 addLine ;
		 addItem:
			[ : item | item
				 contents: 'IDE' translated ;
				 help: 'Remove the application menu -- for further development.' translated ;
				 target: self worldClass ;
				 selector: #reset ]! !

!MagmaWorldMainDockingBar methodsFor: 'help menu' stamp: 'cmm 9/11/2011 21:19'!
helpMenuOn: aDockingBarMenuMorph 
	aDockingBarMenuMorph addItem:
		[ : item | item
			 contents: 'Help' translated ;
			 addSubMenu: [ : menu |  self helpSubmenuOn: menu ] ]! !

!MagmaWorldMainDockingBar methodsFor: 'overridden' stamp: 'cmm 9/11/2011 21:40'!
helpSubmenuOn: aDockingBarMenuMorph
	"Subclasses override as desired."! !

!MagmaWorldMainDockingBar methodsFor: 'construction' stamp: 'cmm 9/11/2011 21:53'!
menusOn: aDockingBarMorph 
	| appMenu |
	appMenu := self
		 squeakMenuOn: aDockingBarMorph ;
		 applicationMenusOn: aDockingBarMorph.
	self
		 exitWorldMenuItemOn: appMenu ;
		 helpMenuOn: aDockingBarMorph! !

!MagmaWorldMainDockingBar methodsFor: 'squeak menu' stamp: 'cmm 9/11/2011 20:49'!
quitMenuItemOn: menu
	menu addItem: [ :item |
		item
			contents: 'Quit' translated;
			help: 'Quit back to OS' translated;
			icon: MenuIcons smallQuitIcon;
			target: self;
			selector: #quitSqueak ]! !

!MagmaWorldMainDockingBar methodsFor: 'squeak menu' stamp: 'cmm 7/24/2011 15:10'!
saveAndQuitMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Save And Quit' translated;
			help: 'Save the current state of the desktop on disk, then quit.' translated;
			icon: MenuIcons smallQuitIcon;
			target: self;
			selector: #saveAndQuitSqueak ]! !

!MagmaWorldMainDockingBar methodsFor: 'squeak menu' stamp: 'cmm 7/24/2011 15:10'!
saveAsMenuItemOn: menu

	menu addItem: [ :item |	
		item
			contents: 'Save As...' translated;
			help: 'Save the current state of desktop on disk under a new name' translated;
			icon: MenuIcons smallSaveAsIcon;
			target: self;
			selector: #saveImageAs ]! !

!MagmaWorldMainDockingBar methodsFor: 'squeak menu' stamp: 'cmm 7/24/2011 15:10'!
saveMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Save' translated;
			help: 'Save the current state of the desktop on disk' translated;
			icon: MenuIcons smallSaveIcon;
			target: self;
			selector: #saveImage ]! !

!MagmaWorldMainDockingBar methodsFor: 'squeak menu' stamp: 'cmm 11/23/2010 18:07'!
squeakMenuOn: aDockingBar 
	"Same as super, except removes the 'Save as new version' option."
	aDockingBar addItem:
		[ : item | item
			 contents: 'Image' ;
			 addSubMenu:
			[ : menu | self
				 saveMenuItemOn: menu ;
				 saveAsMenuItemOn: menu.
			menu addLine.
			self
				 saveAndQuitMenuItemOn: menu ;
				 quitMenuItemOn: menu ] ]! !

!MagmaWorldMainDockingBar methodsFor: 'overridden' stamp: 'cmm 9/11/2011 21:02'!
worldClass
	"Answer the subclass of MagmaWorld which goes with this menu."
	^ MagmaWorld! !

!FlapTab methodsFor: '*magma-squeak-client' stamp: 'cmm 8/25/2011 23:35'!
isImmutableInMagma
	^ self maUsesStandardStorage not! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:16'!
browseClassVersionsInMcService
	^ ServiceAction
		id: #browseClassVersionsInMc
		text: 'browse mc versions'
		button: 'mc'
		description: 'Browse the Monticello history of this class'' definitions from the code repository.'
		action:
			[ : aBrowserRequestor | aBrowserRequestor browseClassVersionsInMc ]
		condition:
			[ : aBrowserRequestor | aBrowserRequestor canBrowseMcClassVersions ]! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:14'!
browseMcClassOriginService
	^ ServiceAction
		id: #browseMcClassOrigin
		text: 'browse mc origin'
		button: 'mc'
		description: 'Browse the Monticello version comments in which this class definition was originally committed.'
		action:
			[ : aBrowserRequestor | aBrowserRequestor browseMcClassOrigin ]
		condition:
			[ : aBrowserRequestor | aBrowserRequestor canBrowseMcClassVersions ]! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:13'!
browseMcMethodOriginService
	^ ServiceAction
		id: #browseMcMethodOrigin
		text: 'browse mc origin'
		button: 'mc'
		description: 'Browse the Monticello version comments in which this version of this method was originally committed.'
		action:
			[ : aBrowserRequestor | aBrowserRequestor browseMcMethodOrigin ]
		condition:
			[ : aBrowserRequestor | aBrowserRequestor canBrowseMcMethodVersions ]! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:14'!
browseMethodVersionsInMcService
	^ ServiceAction
		id: #browseMethodVersionsInMc
		text: 'browse mc versions'
		button: 'mc'
		description: 'Browse the Monticello history of this method from the code repository.'
		action:
			[ : aBrowserRequestor | aBrowserRequestor browseMethodVersionsInMc ]
		condition:
			[ : aBrowserRequestor | aBrowserRequestor canBrowseMcMethodVersions ]! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:02'!
initialize
	(ServiceRegistry current serviceWithId: #browserMethodMenu) services
		 add: self browseMethodVersionsInMcService ;
		 add: self browseMcMethodOriginService.
	(ServiceRegistry current serviceWithId: #browserClassMenu) services
		 add: self browseClassVersionsInMcService ;
		 add: self browseMcClassOriginService! !

!McModel class methodsFor: '*magma-squeak-client-services' stamp: 'cmm 3/15/2011 15:20'!
unload
	| methodMenuServiceCategory classMenuServiceCategory |
	methodMenuServiceCategory := ServiceRegistry current serviceWithId: #browserMethodMenu.
	methodMenuServiceCategory services copy do:
		[ : each | (#(#browseMethodVersionsInMc #browseMcMethodOrigin ) includes: each id) ifTrue: [ methodMenuServiceCategory services remove: each ] ].
	classMenuServiceCategory := ServiceRegistry current serviceWithId: #browserClassMenu.
	classMenuServiceCategory services copy do:
		[ : each | (#(#browseClassVersionsInMc #browseMcClassOrigin ) includes: each id) ifTrue: [ classMenuServiceCategory services remove: each ] ]! !

MaSingleton subclass: #MagmaWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Squeak-Client-Application'!

!MagmaWorld class methodsFor: 'connect' stamp: 'cmm 9/11/2011 20:44'!
connectTo: aMagmaLocation 
	self current: (aMagmaLocation newSession user: (MagmaUser id: self userName)) root! !

!MagmaWorld class methodsFor: 'connect' stamp: 'cmm 9/11/2011 20:38'!
connectTo: hostname port: port 
	"Connect to the running Magma-Server over TCP/IP."
	self connectTo:
		(MagmaRemoteLocation
			host: hostname
			port: port)! !

!MagmaWorld class methodsFor: 'connect' stamp: 'cmm 9/11/2011 20:38'!
connectToPath: pathName 
	"Connect directly to local Magma database files in single-user mode."
	self connectTo: (MagmaLocalLocation path: pathName)! !

!MagmaWorld class methodsFor: 'create' stamp: 'cmm 9/11/2011 20:22'!
createWorldNamed: aString 
	"After using this method to create the application 'World', start up a Magma-Server on it in a separate image.  Then multiple instances of this image may use my connect methods to connect and collaborate in this world."
	MagmaRepositoryController
		create: aString
		root: self new! !

!MagmaWorld class methodsFor: 'overriding' stamp: 'cmm 9/11/2011 22:41'!
current: aMagmaWorld 
	super current: aMagmaWorld.
	MorphicProject current dockingBar: (aMagmaWorld ifNil: [ TheWorldMainDockingBar new ] ifNotNil: [self menuClass new])! !

!MagmaWorld class methodsFor: 'overridden' stamp: 'cmm 9/11/2011 20:46'!
menuClass
	"Applications provide thier own subclass of MagmaWorldMainDockingBar."
	^ TheWorldMainDockingBar! !

!MagmaWorld class methodsFor: 'overridden' stamp: 'cmm 9/11/2011 20:44'!
userName
	^ Utilities authorName! !

!TextLineInterval methodsFor: '*magma-squeak-client' stamp: 'cmm 11/26/2011 16:21'!
isImmutableInMagma
	^ false! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 15:03'!
browseClassVersionsInMc
	"Open a browser on all versions of this class available in the MC repository for this package."
	self getClass
		ifNil: [ UIManager inform: 'No class selected' ]
		ifNotNilDo:
			[ : theClass | theClass mcModel
				ifNil: [ UIManager inform: 'No Magma-based repository for ' , theClass packageInfo packageName ]
				ifNotNilDo:
					[ : mcModel | (MCPatch operations: theClass mcPatchOperations) browse ] ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 15:33'!
browseMcClassOrigin
	"Open a Monticello version browser on the earliest version available in the repository known to contain this version."
	self getClass
		ifNil: [ UIManager inform: 'No method selected' ]
		ifNotNilDo:
			[ : selectedClass | selectedClass mcModel
				ifNil: [ UIManager inform: 'No Magma-based repository for ' , selectedClass packageInfo packageName ]
				ifNotNilDo:
					[ : mcModel | (mcModel originOf: selectedClass asClassDefinition)
						ifNil: [ UIManager inform: selectedClass asString , ' was not found in any Magma-based MC repository.' ]
						ifNotNilDo:
							[ : version | version open ] ] ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 14:55'!
browseMcMethodOrigin
	"Open a Monticello version browser on the earliest version available in the repository known to contain this version."
	self selectedMethodReference
		ifNil: [ UIManager inform: 'No method selected' ]
		ifNotNilDo:
			[ : methodReference | methodReference mcModel
				ifNil: [ UIManager inform: 'No Magma-based repository for ' , methodReference packageInfo packageName ]
				ifNotNilDo:
					[ : mcModel | (mcModel originOf: methodReference asMethodDefinition)
						ifNil: [ UIManager inform: methodReference asString , ' was not found in any Magma-based MC repository.' ]
						ifNotNilDo:
							[ : version | version open ] ] ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 14:49'!
browseMethodVersionsInMc
	"Open a browser on all versions of this method available in the MC repository for this package."
	self selectedMethodReference
		ifNil: [ UIManager inform: 'No method selected' ]
		ifNotNilDo:
			[ : methodReference | methodReference mcModel
				ifNil: [ UIManager inform: 'No Magma-based repository for ' , methodReference packageInfo packageName ]
				ifNotNilDo:
					[ : mcModel | (MCPatch operations: methodReference mcPatchOperations) browse ] ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 15:14'!
canBrowseMcClassVersions
	^ self getClass
		ifNil: [ false ]
		ifNotNilDo:
			[ : class | class mcModel notNil ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/15/2011 15:14'!
canBrowseMcMethodVersions
	^ self selectedMethodReference
		ifNil: [ false ]
		ifNotNilDo:
			[ : methodReference | methodReference mcModel notNil ]! !

!BrowserRequestor methodsFor: '*magma-squeak-client' stamp: 'cmm 3/14/2011 10:15'!
selectedMethodReference
	^ MethodReference
		class: self getClass
		selector: self getSelector! !
McModel initialize!
